package com.inforpires;


import android.graphics.drawable.Drawable;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.BA.ActivityObject;
import anywheresoftware.b4a.BA.Events;


import com.makeramen.RoundedImageView;

import android.content.Context;
import android.content.res.ColorStateList;
import android.content.res.Resources;
import android.content.res.TypedArray;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.graphics.drawable.LayerDrawable;
import android.net.Uri;
import android.util.AttributeSet;
import android.util.Log;
import android.widget.ImageView;
import android.widget.ImageView.ScaleType;

@BA.Author("Nelson Pires")
@BA.ShortName("RoundedImageView")
@BA.Version(1.0F)
@BA.ActivityObject
@Events(values={"Click","LongClick"})

public class RoundedImageViewWrapper extends ViewWrapper<RoundedImageView> {

	public static final ImageView.ScaleType SCALETYPE_CENTER=ScaleType.CENTER; 
	public static final ImageView.ScaleType SCALETYPE_CENTER_CROP=ScaleType.CENTER_CROP;
	public static final ImageView.ScaleType SCALETYPE_CENTER_INSIDE=ScaleType.CENTER_INSIDE;
	public static final ImageView.ScaleType SCALETYPE_FIT_CENTER=ScaleType.FIT_CENTER;
	public static final ImageView.ScaleType SCALETYPE_FIT_END=ScaleType.FIT_END;
	public static final ImageView.ScaleType SCALETYPE_FIT_START=ScaleType.FIT_START;
	public static final ImageView.ScaleType SCALETYPE_FIT_XY=ScaleType.FIT_XY;
	public static final ImageView.ScaleType SCALETYPE_MATRIX=ScaleType.MATRIX;

	public void Initialize(BA ba,String EventName) {
		//setObject(new RoundedImageView(ba.context));
		super.Initialize(ba,EventName);
	}

	public void setImageBitmap(Bitmap bm) {
		getObject().setImageBitmap(bm);
	}
	
	public float getCornerRadius() {
		return getObject().getCornerRadius();
	}

	public void setCornerRadius(float radius) {
		getObject().setCornerRadius(radius);
    }
	
	public boolean getOval() {
		return getObject().isOval();
	}

	public void setOval(boolean oval) {
		getObject().setOval(oval);
	}

	public float getBorderWidth() {
		return getObject().getBorderWidth();
	}

    public void setBorderWidth(float width) {
		getObject().setBorderWidth(width);
	}

	public int getBorderColor() {
		return getObject().getBorderColor();
	}

  	public ColorStateList getBorderColors() {
		return getObject().getBorderColors();
	}

	public void setBorderColors(int[][] states, int[] colors) {
		
		
		getObject().setBorderColor( new ColorStateList (states, colors) );	
	}
	
	public boolean getMutateBackground() {
		return getObject().isMutateBackground();
	}

	public void setMutateBackground(boolean mutate) {
		getObject().setMutateBackground(mutate);
	}
	
	public void setImageDrawable(Drawable drawable) {
		getObject().setImageDrawable(drawable);
	}
	
	public void setScaleType(ScaleType scaleType) {
		getObject().setScaleType(scaleType);
	}

	public ScaleType getScaleType() {
		return getObject().getScaleType();
	}
	
	
	
	@BA.Hide
	public void innerInitialize(BA ba, String eventName, boolean keepOldObject) {
		if (!keepOldObject) setObject(new RoundedImageView(ba.context));
		super.innerInitialize(ba, eventName, true);
	}
	
	
	

}